package com.example.fuzzControll.controller;

import com.example.fuzzControll.exception.AflnetException;
import com.example.fuzzControll.exception.BaseException;
import com.example.fuzzControll.exception.CmdException;
import com.example.fuzzControll.pojo.vo.AjaxResult;
import com.example.fuzzControll.pojo.vo.AlgorithmOneCmdParams;
import com.example.fuzzControll.service.TestService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

/**
 * aflnet测试控制
 */
@Slf4j
@RestController
@RequestMapping("/aflnet")
public class AlfnetController {
    @Autowired
    TestService service;

    /**
     * 算法1 有参数型
     */
    @RequestMapping(value = "/algorithmOneStart", method = RequestMethod.POST)
    public AjaxResult algorithmOneStart(@RequestBody final AlgorithmOneCmdParams algorithmOneCmdParams) {
        System.out.println(algorithmOneCmdParams);
        try {
            new Thread(new Runnable() {
                @Override
                public void run() {
                    service.algorithmOneStart(algorithmOneCmdParams);
                }
            }).start();
        } catch (Exception e) {
            if (e instanceof AflnetException || e instanceof CmdException) {
                log.error(((BaseException) e).getDefaultMessage());
            }
            return AjaxResult.error("测试启动失败！");
        }
        return AjaxResult.success("测试已启动！");
    }

    /**
     * 算法2 无参数型
     */
    @RequestMapping(value = "/algorithmTwoStart", method = RequestMethod.POST)
    public AjaxResult algorithmTwoStart(@RequestBody final AlgorithmOneCmdParams algorithmOneCmdParams) {
        System.out.println(algorithmOneCmdParams);
        //todo 捕获子线程错误
        try {
            new Thread(new Runnable() {
                @Override
                public void run() {
                    service.algorithmTwoStart(algorithmOneCmdParams);
                }
            }).start();
        } catch (Exception e) {
            if (e instanceof AflnetException || e instanceof CmdException) {
                log.error(((BaseException) e).getDefaultMessage());
            }
            return AjaxResult.error("测试启动失败！");
        }
        return AjaxResult.success("测试已启动！");
    }
    /**
     * 测试停止
     */
    @RequestMapping(value = "/testStop", method = RequestMethod.GET)
    public AjaxResult testStop() {
        try {
            service.testStop();
        } catch (AflnetException e) {
            log.error(e.getDefaultMessage());
            return AjaxResult.error("测试停止失败！");
        }
        return AjaxResult.success("测试停止成功！");
    }

}